<?
$SECTION=5;
$PAGE=0;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

$query = "SELECT Enabled, DefaultNat, DefaultRedirectGateway FROM OpenvpnSettings";
$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);

$openVpnEnabled=($res['Enabled']) ? "checked" : "";
$openVpnDefaultNatChecked=($res['DefaultNat']) ? "checked" : "";
$openVpnDefaultRedirectGatewayChecked=($res['DefaultRedirectGateway']) ? "checked" : "";

$query = "SELECT Enabled, DefaultNat, DefaultRedirectGateway FROM MobileipSettings";
$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);

$mobileIpEnabled=($res['Enabled']) ? "checked" : "";
$mobileIpDefaultNatChecked=($res['DefaultNat']) ? "checked" : "";
$mobileIpDefaultRedirectGatewayChecked=($res['DefaultRedirectGateway']) ? "checked" : "";

// find free client IDs

$client_ids = Array();

for ($i=1; $i<$maxRemoteStations; $i++)
{
	$stmt = $cfg->pdb->prepare("SELECT COUNT(*) as count FROM VpnClients WHERE ClientName=:client");
	$client="CLIENT_$i";
	$stmt->execute(array(':client' => $client));
	$res = $stmt->fetchColumn();
	if ($res==0)
		array_push($client_ids, $i);	
}

if (count($client_ids)==0)
{
	vp_error("Maximum number of clients reached!");
	$maxClientDisable="disabled";
} else {
	$maxClientDisable="";
}

?>

<script type="text/javascript">

function typeSelected(obj) {
	var natField = document.getElementById("nat");
	var redirectGatewayField = document.getElementById("redirectgateway");

	if (obj.value=="openvpn")
	{
		natChecked = ("<?= $openVpnDefaultNatChecked ?>".length>0);
		redirectGatewayChecked = ("<?= $openVpnDefaultRedirectGatewayChecked ?>".length>0);
		redirectGatewayDisabled = 0;
	} else {
		natChecked = ("<?= $mobileIpDefaultNatChecked ?>".length>0);
		redirectGatewayChecked = ("<?= $mobileIpDefaultRedirectGatewayChecked ?>".length>0);
		redirectGatewayDisabled = 1;
	}

	natField.checked = natChecked;
	redirectGatewayField.checked = redirectGatewayChecked;
	redirectGatewayField.disabled = redirectGatewayDisabled;
}

</script>

<div class="item">
	<div class="content_top">
	<h1>Auto Setup</h1>
	<br />
	<h2>Join VPN</h2>
	<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<form method="post" action="autosetup-join-vpn-result.php" name="form1">
			<h3>Device Information</h3>
			<br />
			<table>
				<tr>
					<td class="c2_left"><?= _("System Type")?>:</td>
					<td class="c2_right">
						<?=$_GET['type']?>
						<input type="hidden" name="type" value="<?=$_GET['type']?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("System Serial Number")?>:</td>
					<td class="c2_right">
						<?=$_GET['serial']?>
						<input type="hidden" name="serial" value="<?=$_GET['serial']?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Current IP Address")?>:</td>
					<td class="c2_right">
						<?=$_GET['inetip']?>
						<input type="hidden" name="inetip" value="<?=$_GET['inetip']?>" />
						<input type="hidden" name="autosetupip" value="<?=$_GET['autosetupip']?>" />
					</td>
				</tr>
			</table>
			<br />
			<h3>VPN Settings</h3>
			<br />
			<table>
				<tr>
					<td class="c2_left"><?= _("VPN Type")?>:</td>
					<td class="c2_right">
						<select id="protocol" name="protocol" onChange="typeSelected(this)" <?=$maxClientDisable ?> >
<? if ($openVpnEnabled) { ?>
							<option value="openvpn" selected>OpenVPN</option>
<? } ?>
<? if (mobileIpAvailable()) {
		if ($mobileIpEnabled) {
?>
								<option value="mobileip">Mobile IP</option>
<?	}
	 } 
?>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Client ID")?>:</td>
					<td class="c2_right">
						<select name="client-id" <?=$maxClientDisable ?>>
<? foreach ($client_ids as $id) { ?>
							<option value="<?=$id ?>"><?=$id ?></option>
<? } ?>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Description")?>:</td>
					<td class="c2_right">
						<input type="text" name="description" value="" size=64 <?=$maxClientDisable ?> />
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Use 1:1 NAT")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="nat" id="nat" value="1" <?=$openVpnDefaultNatChecked ?> <?=$maxClientDisable ?>/>
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Redirect Gateway")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="redirectgateway" id="redirectgateway" value="1" <?=$maxClientDisable ?>/>
					</td>
				</tr>
			</table>
			<br /><?  vp_display_status(); ?>
			<br />
			<div id="cnt_right_bottom">
				<input type="submit" name="Join" value="<?=_("Join")?>" <?=$maxClientDisable ?> />
			</div>
		</form>
	</div>
</div> 

<? require_once("footer.php") ?>

