<?
$SECTION=2;
$PAGE=2;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if (isset($_POST["Apply"])) {
	$_SESSION['NM_ADMIN_PASSWORD'] = $_POST["admin-password"];
	$_SESSION['NM_ETHERNET'] = (isset($_POST["ethernet"])) ? $_POST["ethernet"] : "0";
	$_SESSION['NM_WLAN'] = (isset($_POST["wlan"])) ? $_POST["wlan"] : "0";
	$_SESSION["NM_WLAN_SSID"] = $_POST["wlan-ssid"];
	$_SESSION['NM_WLAN_ENCRYPTION'] = $_POST["wlan-encryption"];
	$_SESSION['NM_WLAN_CIPHER_ALG'] = $_POST["wlan-cipher-alg"];
	$_SESSION["NM_WLAN_KEY"] = $_POST["wlan-key"];
	$_SESSION['NM_WWAN'] = (isset($_POST["wwan"])) ? $_POST["wwan"] : "0";
	$_SESSION["NM_WWAN_APN"] = $_POST["wwan-apn"];
	$_SESSION["NM_WWAN_USERNAME"] = $_POST["wwan-username"];
	$_SESSION["NM_WWAN_PASSWORD"] = $_POST["wwan-password"];

	$hasConnectivity=0;

	if (!strlen($_SESSION["NM_ADMIN_PASSWORD"]))
	{
		vp_error("Invalid administrator password! Minimum 6 character required.");
	}
	
	if (isset($_POST["ethernet"])) {
		$hasConnectivity=1;
	}

	if (isset($_POST["wlan"])) {
		$hasConnectivity=1;
		if (!strlen($_SESSION["NM_WLAN_SSID"]))
		{
			vp_error("No SSID specified!");
		}
		if ($_POST["wlan-encryption"]!="off")
		{
			if ((strlen($_SESSION["NM_WLAN_KEY"])<8) || (strlen($_SESSION["NM_WLAN_KEY"])>63))
			vp_error("WPA-key lenght must be in the range 8..63 characters");
		}
	}
	if (isset($_POST["wwan"])) {
		$hasConnectivity=1;
		if (!strlen($_SESSION["NM_WWAN_APN"]))
		{
			vp_error("No APN specified!");
		}
	}

	if ($hasConnectivity==0)
	{
		vp_error("You need to enable at least one WAN interface!");
	}

	if (!vp_is_error()) {
		$query = "UPDATE AutosetupSettings SET " .
			"AdminPassword=:adminpassword," .
			"UseEthernet=:useethernet," .
			"UseWlan=:usewlan," .
			"WlanSsid=:wlanssid," .
			"WlanSecurityMode=:wlansecuritymode," .
			"WlanCipherAlg=:wlancipheralg," .
			"WlanKey=:wlankey," .
			"UseWwan=:usewwan," .
			"WwanApn=:wwanapn," .
			"WwanUsername=:wwanusername," .
			"WwanPassword=:wwanpassword";
		$stmt = $cfg->pdb->prepare($query);
		$stmt->execute(array(':adminpassword' => $_SESSION['NM_ADMIN_PASSWORD'],
													':useethernet' => $_SESSION['NM_ETHERNET'],
													':usewlan' => $_SESSION['NM_WLAN'],
													':wlanssid' => $_SESSION["NM_WLAN_SSID"],
													':wlansecuritymode' => $_SESSION['NM_WLAN_ENCRYPTION'],
													':wlancipheralg' => $_SESSION['NM_WLAN_CIPHER_ALG'],
													':wlankey' => $_SESSION["NM_WLAN_KEY"],
													':usewwan' => $_SESSION['NM_WWAN'],
													':wwanapn' => $_SESSION["NM_WWAN_APN"],
													':wwanusername' => $_SESSION["NM_WWAN_USERNAME"],
													':wwanpassword' => $_SESSION["NM_WWAN_PASSWORD"]
													));
		exec("sudo /usr/lib/vpnportal/action/build-openvpn-auto-setup-client-config", $output, $res);
		if ($res==0)
		{
			if ($cfg->getStage()==Config::STAGE_SERVER_CONFIGURED)
			{
				$cfg->setStage(Config::STAGE_AUTOSETUP_CONFIGURED);
				header('Location: autosetup-download.php');
				exit;
			}
		} else {
			vp_error("Could not build autosetup configuration!");
		}
	}
} else {
	$query = "SELECT * FROM AutosetupSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
	$_SESSION['NM_ADMIN_PASSWORD'] = $res['AdminPassword'];
	$_SESSION['NM_ETHERNET'] = $res['UseEthernet'];
	$_SESSION['NM_WLAN'] = $res['UseWlan'];
	$_SESSION["NM_WLAN_SSID"] = $res['WlanSsid'];
	$_SESSION['NM_WLAN_ENCRYPTION'] = $res['WlanSecurityMode'];
	$_SESSION['NM_WLAN_CIPHER_ALG'] = $res['WlanCipherAlg'];
	$_SESSION["NM_WLAN_KEY"] = $res['WlanKey'];
	$_SESSION['NM_WWAN'] = $res['UseWwan'];
	$_SESSION["NM_WWAN_APN"] = $res['WwanApn'];
	$_SESSION["NM_WWAN_USERNAME"] = $res['WwanUsername'];
	$_SESSION["NM_WWAN_PASSWORD"] = $res['WwanPassword'];
}

$P_NAME=array();
$P_APNS=array();
$P_USERS=array();
$P_PASSWORDS=array();

$providers=fopen("/usr/lib/vpnportal/common/providers", "r");
if ($providers)
{
	$i=0;
	while (TRUE)
	{
		$provider=fgets($providers);
		if ($provider==FALSE) break;
		$tok=explode(",", trim($provider));
		$name=$tok[0];
		array_push($P_NAME, $name);
		array_push($P_APNS, $tok[1]);
		array_push($P_USERS, $tok[2]);
		array_push($P_PASSWORDS, $tok[3]);
		$i++;
	}
	fclose($providers);
}

?>

<script type="text/javascript">
	function setWlanStatus() {
		var wlan = document.getElementById("wlan");
		var wlanenc = document.getElementById("wlan-encryption");
		var mydiv = document.getElementById("wlan-div");
		var encdiv = document.getElementById("wlan-enc-div");
		if (wlan.checked) {
			mydiv.style.visibility="visible";
			if (wlanenc.value!="off")
			{
				encdiv.style.visibility="visible";
			} else {
				encdiv.style.visibility="collapse";
			}
		} else {
			mydiv.style.visibility="collapse";
			encdiv.style.visibility="collapse";
		}
	}

	function wlanEncryptionChanged(obj) {
		var encdiv = document.getElementById("wlan-enc-div");
	
		if (obj.value=="off")
		{
			encdiv.style.visibility="collapse";
		} else {
			encdiv.style.visibility="visible";
		}
	}

	function setWwanStatus() {
		var st = document.getElementById("wwan");
		var mydiv = document.getElementById("wwan-div");
		if (st.checked) {
			mydiv.style.visibility="visible";
		} else {
			mydiv.style.visibility="collapse";
		}
	}

	var providers = [
<?
	for ($i=0; $i<count($P_NAME); $i++)
	{
		$name=$P_NAME[$i];
		$apn=$P_APNS[$i];
		$user=$P_USERS[$i];
		$password=$P_PASSWORDS[$i];
		echo "[\"$apn\",\"$user\",\"$password\"],\n";
	}
?>
	];

	function wwanProviderChanged(obj) {
		var apn = document.getElementById("wwan-apn");
		var username = document.getElementById("wwan-username");
		var password = document.getElementById("wwan-password");
		username.value=apn.value;
		apn.value=providers[obj.value][0];
		username.value=providers[obj.value][1];
		password.value=providers[obj.value][2];
	}


</script>

<div class="item">
	<div class="content_top">
	<h1>Remote Stations</h1>
	<br />
	<h2>Configuration Template</h2>
	<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<font color="green">Please define the settings to be included in the configuration file that is uploaded to your routers.</font><br /><br />
		<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
			<table>
				<tr>
					<td width="100%">
						<table width="70%">
							<tr>
								<td width="30%" class="c2_left"><?= _("Router Password")?>:</td>
								<td width="70%" class="c2_right">
									<input type="text" name="admin-password" id="admin-password" value="<?=htmlspecialchars($_SESSION["NM_ADMIN_PASSWORD"], ENT_QUOTES, 'UTF-8');?>" size=60  />
								</td>
							</tr>
							<tr>
								<td colspan=2><br /></td>
							</tr>
							<tr>
								<td class="c2_left">
									<?=_("Use Ethernet")?>:
								</td>
								<td class="c2_right">
									<input type="checkbox" name="ethernet" value="1" <? if ($_SESSION['NM_ETHERNET'] == "1") echo 'checked'; ?> />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<table width="70%">
							<tr>
								<td colspan=2><br /></td>
							</tr>
							<tr>
								<td width="30%" class="c2_left">
									<?=_("Use WLAN")?>:
								</td>
								<td width="70%" class="c2_right">
									<input type="checkbox" name="wlan" id="wlan" onClick="setWlanStatus()" value="1" <?=($_SESSION['NM_WLAN'] == "1") ? 'checked' : '' ?> />
								</td>
							</tr>
						</table>
					<td>
				</tr>
				<tr>
					<td>
						<div id="wlan-div" style="visibility:<?=($_SESSION['NM_WLAN'] == "1") ? 'visible' : 'collapse' ?>">
							<table width="70%">
								<tr>
									<td width="5%"></td>
									<td width="25%" class="c2_left"><?= _("SSID")?>:</td>
									<td width="70%" class="c2_right">
										<input type="text" name="wlan-ssid" id="wlan-ssid" value="<?=htmlspecialchars($_SESSION["NM_WLAN_SSID"], ENT_QUOTES, 'UTF-8');?>" size=60 />
									</td>
								</tr>
								<tr>
									<td></td>
									<td class="c2_left"><?= _("Security mode")?>:</td>
									<td class="c2_right">
										<select id="wlan-encryption" name="wlan-encryption" onChange="wlanEncryptionChanged(this)">
											<option value="off" <? if ($_SESSION['NM_WLAN_ENCRYPTION'] == "off") echo 'selected'; ?>>None</option>
											<option value="wpa-psk" <? if ($_SESSION['NM_WLAN_ENCRYPTION'] == "wpa-psk") echo 'selected'; ?>>WPA-PSK</option>
										</select>
									</td>
								</tr>
							</table>
						</div>
						<div id="wlan-enc-div" style="visibility:<?=(($_SESSION['NM_WLAN_ENCRYPTION'] != "off") && ($_SESSION['NM_WLAN'] == "1")) ? 'visible' : 'collapse' ?>">
							<table width="70%">
								<tr>
									<td width="5%"></td>
									<td width="25%" class="c2_left"><?= _("WPA cipher")?>:</td>
									<td width="70%" class="c2_right">
										<select id="wlan-cipher-alg" name="wlan-cipher-alg">
											<option value="tkip" <? if ($_SESSION['NM_WLAN_CIPHER_ALG'] == "tkip") echo 'selected'; ?>>TKIP</option>
											<option value="ccmp" <? if ($_SESSION['NM_WLAN_CIPHER_ALG'] == "ccmp") echo 'selected'; ?>>CCMP</option>
										</select>
									</td>
								</tr>
								<tr>
									<td></td>
									<td class="c2_left"><?= _("Passphrase")?>:</td>
									<td class="c2_right">
										<input type="text" id="wlan-key" name="wlan-key" value="<?=htmlspecialchars($_SESSION["NM_WLAN_KEY"], ENT_QUOTES, 'UTF-8');?>" size=60 />
									</td>
								</tr>
							</table>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<table width="70%">
							<tr>
								<td colspan=2><br /></td>
							</tr>
							<tr>
								<td width="30%" class="c2_left">
									<?=_("Use WWAN")?>:
								</td>
								<td width="70%" class="c2_right">
									<input type="checkbox" name="wwan" id="wwan" onClick="setWwanStatus()" value="1" <?=($_SESSION['NM_WWAN'] == "1") ? 'checked' : '' ?> />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td>
						<div id="wwan-div" style="visibility:<?=($_SESSION['NM_WWAN'] == "1") ? 'visible' : 'collapse' ?>">
							<table width="70%">
								<tr>
									<td width="5%"></td>
									<td width="25%" class="c2_left"><?= _("Provider")?>:</td>
									<td width="70%" class="c2_right">
										<select id="wwan-provider" name="wwan-provider" onChange="wwanProviderChanged(this)">
											<option value="Manual entry" selected>[Select one or enter details below]</option>
<?
	for ($i=0; $i<count($P_NAME); $i++)
	{
		$name=$P_NAME[$i];
		echo "<option value=\"$i\">$name</option>";
	}
?>
										</select>
									</td>
								</tr>
								<tr>
									<td width="5%"></td>
									<td width="25%" class="c2_left"><?= _("APN")?>:</td>
									<td width="70%" class="c2_right">
										<input type="text" id="wwan-apn" name="wwan-apn" value="<?=htmlspecialchars($_SESSION["NM_WWAN_APN"], ENT_QUOTES, 'UTF-8');?>" size=60 />
									</td>
								</tr>
								<tr>
									<td></td>
									<td class="c2_left"><?= _("Username")?>:</td>
									<td class="c2_right">
										<input type="text" id="wwan-username" name="wwan-username" value="<?=htmlspecialchars($_SESSION["NM_WWAN_USERNAME"], ENT_QUOTES, 'UTF-8');?>" size=60 />
									</td>
								</tr>
								<tr>
									<td></td>
									<td class="c2_left"><?= _("Password")?>:</td>
									<td class="c2_right">
										<input type="text" id="wwan-password" name="wwan-password" value="<?=htmlspecialchars($_SESSION["NM_WWAN_PASSWORD"], ENT_QUOTES, 'UTF-8');?>" size=60 />
									</td>
								</tr>
							</table>
						</div>
					</td>
				</tr>
			</table>
			<br /><?  vp_display_status(); ?>
			<br />
			<div id="cnt_right_bottom">
				<input type="submit" name="Apply" value="<?=_("Apply")?>" />
			</div>
		</form>
	</div>
</div> 

<? require_once("footer.php") ?>

