<?
$SECTION=6;
$PAGE=3;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if ($_SESSION['NM_CUR_USERNAME']!="admin")
{
	header('Location: login.php');
	exit;
}

if (isset($_POST["Apply"])) {
	$_SESSION['NM_ENABLED'] = (isset($_POST["enabled"])) ? $_POST["enabled"] : "0";
	$_SESSION['NM_LEASE_START_ADDRESS'] = $_POST["lease-start-address"];
	$_SESSION["NM_LEASE_END_ADDRESS"] = $_POST["lease-end-address"];
	$_SESSION["NM_PRESHARED_KEY"] = $_POST["preshared-key"];

	if ($_SESSION['NM_ENABLED']!=0)
	{
		if ($_SESSION['NM_PRESHARED_KEY']=="") {
			vp_error("Preshared key is empty!");
		}
		if ($_SESSION['NM_LEASE_START_ADDRESS'] == "" ||
			!valid_address($_SESSION['NM_LEASE_START_ADDRESS'])) {
			vp_error("Invalid leases start address!");
		}
		
		if ($_SESSION["NM_LEASE_END_ADDRESS"] == "" ||
			!valid_address($_SESSION["NM_LEASE_END_ADDRESS"])) {
			vp_error("Invalid leases end address!");
		}
	}
	
	if (!vp_is_error()) {
		$query = "UPDATE L2tpIpsecSettings SET " .
				"Enabled=:enabled," .
				"V4LeaseStartAddress=:v4leasestartaddress," .
				"V4LeaseEndAddress=:v4leaseendaddress," .
				"PresharedKey=:presharedkey";
		$stmt = $cfg->pdb->prepare($query);
		$res = $stmt->execute(array(':enabled' => $_SESSION['NM_ENABLED'] ,
														':v4leasestartaddress' => $_SESSION['NM_LEASE_START_ADDRESS'],
														':v4leaseendaddress' => $_SESSION["NM_LEASE_END_ADDRESS"],
														':presharedkey' => $_SESSION["NM_PRESHARED_KEY"]
													));
		if ($res)
		{
			exec("sudo /usr/lib/vpnportal/action/modify-l2tpipsec", $output, $res);
		} else {
			vp_error("Could not modify L2TP/IPSEC settings!");
		}
	}
} else {
	$query = "SELECT * FROM L2tpIpsecSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
	$_SESSION['NM_ENABLED'] = $res['Enabled'];
	$_SESSION['NM_LEASE_START_ADDRESS'] = $res['V4LeaseStartAddress'];
	$_SESSION['NM_LEASE_END_ADDRESS'] = $res['V4LeaseEndAddress'];
	$_SESSION["NM_PRESHARED_KEY"] = $res['PresharedKey'];
}

$nets=$cfg->getAvailableNetworks($_SESSION['NM_LEASE_START_ADDRESS']);
$nrnets=count($nets);
for ($i=0; $i<$nrnets; $i++)
{
	$tmp=explode(".", $nets[$i]);
	$tmp=$tmp[0] . "." . $tmp[1] . "." . $tmp[2] . ".1";
	$nets[$i] = $tmp;
}
?>

<script type="text/javascript">

function ipChange(obj) {
	var leaseEndField = document.getElementById("lease-end-address");
	var leaseEndHiddenField = document.getElementById("lease-end-address-hidden");
	var tmp = obj.value.split(".");

	leaseEndField.value = tmp[0] + "." + tmp[1] + "." + tmp[2] + ".127";
	leaseEndHiddenField.value = leaseEndField.value;
}

</script>

<div class="item">
	<div class="content_top">
		<h1>Server</h1>
		<br />
		<h2>L2TP / IPsec</h2>
		<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
			<table>
				<tr>
					<td class="c2_left">
						<?=_("Enabled")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="enabled" value="1" <?=($_SESSION['NM_ENABLED'] == "1") ? 'checked' : '' ?> />
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Preshared secret")?>:</td>
					<td class="c2_right">
						<input type="text" name="preshared-key" value="<?=htmlspecialchars($_SESSION["NM_PRESHARED_KEY"], ENT_QUOTES, 'UTF-8');?>" size=60 />
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Leases Start Address")?>:</td>
					<td class="c2_right">
						<select name="lease-start-address" id="lease-start-address" onChange="ipChange(this)">
<? foreach ($nets as $net) { ?>
							<option value="<?=$net ?>" <? if ($_SESSION['NM_LEASE_START_ADDRESS'] == $net) echo 'selected'; ?>><?=$net ?></option>
<? } ?>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Leases End Address")?>:</td>
					<td class="c2_right">
						<input type="text" name="lease-end-address" id="lease-end-address" value="<?=htmlspecialchars($_SESSION["NM_LEASE_END_ADDRESS"], ENT_QUOTES, 'UTF-8');?>" size=60 disabled />
						<input type="hidden" name="lease-end-address" id="lease-end-address-hidden" value="<?=htmlspecialchars($_SESSION["NM_LEASE_END_ADDRESS"], ENT_QUOTES, 'UTF-8');?>" size=60 />
					</td>
				</tr>
			</table>
			<br />
<? if (isset($_POST["Apply"])) { ?>
		<? vp_display_status(); ?>
<? } ?>
			<br />
			<div id="cnt_right_bottom_1">
				<input type="submit" name="Apply" value="<?=_("Apply")?>" />
			</div>
		</form>
		<br />
 </div>
</div>


<? require_once("footer.php") ?>
