<?
$SECTION=2;
$PAGE=4;
require_once("header.php");
require_once("utils.php");
require_once("config.php");
require_once("vpn-client-db-utils.php");

if (isset($_POST['Add']))
{
	$_SESSION["NM_VPN_TYPE"] = $_POST['protocol'];
	$_SESSION["NM_CLIENT_ID"] = $_POST['client-id'];
	$_SESSION["NM_SYSTEM_TYPE"] = $_POST['type'];
	$_SESSION["NM_SYSTEM_SERIAL"] = $_POST['serial'];
	$_SESSION["NM_SYSTEM_SERIAL"] = str_replace(":","",$_SESSION["NM_SYSTEM_SERIAL"]);
	$_SESSION["NM_SYSTEM_SERIAL"] = strtoupper($_SESSION["NM_SYSTEM_SERIAL"]);
	$_SESSION["NM_DESCRIPTION"] = $_POST['description'];
	$_SESSION["NM_NAT"] = (isset($_POST['nat'])) ? 1 : 0;
	$_SESSION["NM_REDIRECT_GATEWAY"] = (isset($_POST['redirectgateway'])) ? 1 : 0;

	if (strlen($_SESSION["NM_SYSTEM_SERIAL"])==0)
	{
		$_SESSION["NM_SYSTEM_SERIAL"]="";
	} else if ((!ctype_xdigit($_SESSION["NM_SYSTEM_SERIAL"])) || (strlen($_SESSION["NM_SYSTEM_SERIAL"])!=12)) {
		vp_error("Invalid serial number!");
	}

	if (!vp_is_error())
	{
		$serial=$_SESSION["NM_SYSTEM_SERIAL"];
		if (strlen($serial)==0)
		{
			$serial="UNKNOWN";
		}
		$protocol=$_SESSION["NM_VPN_TYPE"];
		$description=$_SESSION["NM_DESCRIPTION"];
	
		$err="";
		$clientName='';
		$clientIpAddress='';
		$routedNetNetworkAddress='';
		$routedNetNetworkMask='';
		$success=addClient($cfg, $err, $clientName, $clientIpAddress, 
									$routedNetNetworkAddress, $routedNetNetworkMask);

		// build configuration file
		if ($success)
		{
			$sysreturn=0;
			if ($protocol=="openvpn")
			{
				if ($_SESSION["NM_SYSTEM_TYPE"]=="GENERIC")
				{
					$err=exec("sudo /usr/lib/vpnportal/action/build-openvpn-generic-config $clientName", $output, $sysreturn);
					if ($sysreturn) vp_error("Could not build generic client openvpn configuration!");
				} else {
					$err=exec("sudo /usr/lib/vpnportal/action/build-openvpn-client-config-from-autosetup-config template $clientName $serial", $output, $sysreturn);
					if ($sysreturn) vp_error("Could not build client openvpn configuration!");
				}
			} else {
				$err=exec("sudo /usr/lib/vpnportal/action/build-mobileip-client-config-from-autosetup-config template $clientName $serial", $output, $sysreturn);
				if ($sysreturn) vp_error("Could not build client mobile ip configuration!");
				if (!vp_is_error())
				{
					$err=exec("sudo /usr/lib/vpnportal/action/modify-mobileip", $output, $sysreturn);
					if ($sysreturn) vp_error("Could not modify server mobile ip configuration!");
				}
			}
		} else {
			vp_error("Could not add client!");
		}
		if (!vp_is_error())
		{
			header('Location: vpn-client-details.php?client=' . $clientName);
			exit;
		}
	}
} 

if ((!isset($_POST['Add'])) || (vp_is_error ()))
{
	$query = "SELECT Enabled, DefaultNat, DefaultRedirectGateway FROM OpenvpnSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);

	$openVpnEnabled=($res['Enabled']) ? "checked" : "";
	$openVpnDefaultNatChecked=$res['DefaultNat'];
	$openVpnDefaultRedirectGatewayChecked=$res['DefaultRedirectGateway'];

	$query = "SELECT Enabled, DefaultNat, DefaultRedirectGateway FROM MobileipSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);

	$mobileIpEnabled=($res['Enabled']) ? "checked" : "";
	$mobileIpDefaultNatChecked=$res['DefaultNat'];
	$mobileIpDefaultRedirectGatewayChecked=$res['DefaultRedirectGateway'];

	// find free client IDs

	$client_ids = Array();

	for ($i=1; $i<=$maxRemoteStations; $i++)
	{
		$stmt = $cfg->pdb->prepare("SELECT COUNT(*) as count FROM VpnClients WHERE ClientName=:client");
		$client="CLIENT_$i";
		$stmt->execute(array(':client' => $client));
		$res = $stmt->fetchColumn();
		if ($res==0)
			array_push($client_ids, $i);
	}

	if (count($client_ids)==0)
	{
		if ($licEngine->haveValidLicenseKey()) {
			vp_error("Maximum number of remote stations reached!");
		} else {
			vp_error("Maximum number of remote stations in trial mode reached! Please purchase a license for more stations.");
		}
		$maxClientDisable="disabled";
	} else {
		$maxClientDisable="";
	}
}

if (!isset($_POST['Add']))
{
	$_SESSION["NM_VPN_TYPE"] = "";
	$_SESSION["NM_CLIENT_ID"] = "";
	$_SESSION["NM_SYSTEM_TYPE"] = "";
	$_SESSION["NM_SYSTEM_SERIAL"] = "";
	$_SESSION["NM_DESCRIPTION"] = "";
	if ($openVpnEnabled) {
		$_SESSION["NM_NAT"] = $openVpnDefaultNatChecked;
		$_SESSION["NM_REDIRECT_GATEWAY"] = $openVpnDefaultRedirectGatewayChecked;
	} else {
		$_SESSION["NM_NAT"] = $mobileIpDefaultNatChecked;
		$_SESSION["NM_REDIRECT_GATEWAY"] = $mobileIpDefaultRedirectGatewayChecked;
	}
}

?>

<script type="text/javascript">

function protocolSelected(obj) {
	var natField = document.getElementById("nat");
	var redirectGatewayField = document.getElementById("redirectgateway");

	if (obj.value=="openvpn")
	{
		natChecked =<?=$openVpnDefaultNatChecked ?>;
		redirectGatewayChecked=<?=$openVpnDefaultRedirectGatewayChecked ?>;
		redirectGatewayDisabled=0;
	} else {
		natChecked =<?=$mobileIpDefaultNatChecked ?>;
		redirectGatewayChecked=<?=$mobileIpDefaultRedirectGatewayChecked ?>;
		redirectGatewayDisabled=1;
	}

	natField.checked = natChecked;
	redirectGatewayField.checked = redirectGatewayChecked;
	redirectGatewayField.disabled = redirectGatewayDisabled;
}

function systemTypeChanged(obj) {
	var serial = document.getElementById("serial");
	var nat = document.getElementById("nat");
	
	if (obj.value=="GENERIC")
	{
		serial.disabled=true;
		nat.disabled=true;
	} else {
		serial.disabled=false;
		nat.disabled=false;
	}
}

</script>

<div class="item">
	<div class="content_top">
	<h1>Remote Stations</h1>
	<br />
	<h2>Manual Setup</h2>
	<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
			<table>
				<tr>
					<td class="c2_left"><?= _("VPN Type")?>:</td>
					<td class="c2_right">
						<select id="protocol" name="protocol" onChange="protocolSelected(this)">
<? if ($openVpnEnabled) { ?>
							<option value="openvpn" <? if ($_SESSION["NM_VPN_TYPE"]=="openvpn") echo "selected"; ?> >OpenVPN</option>
<? } ?>
<? if (mobileIpAvailable()) {
		if ($mobileIpEnabled) {
?>
								<option value="mobileip" <? if ($_SESSION["NM_VPN_TYPE"]=="mobileip") echo "selected"; ?> >Mobile IP</option>
<?	}
	 }
?>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Client ID")?>:</td>
					<td class="c2_right">
						<select name="client-id" <?=$maxClientDisable ?>>
<? foreach ($client_ids as $id) { ?>
							<option value="<?=$id ?>" <? if ($_SESSION["NM_CLIENT_ID"]==$id) echo "selected"; ?> ><?=$id ?></option>
<? } ?>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("System Type")?>:</td>
					<td class="c2_right">
						<select name="type" onChange="systemTypeChanged(this)">
							<option value="NB1600" <? if ($_SESSION["NM_SYSTEM_TYPE"]=="NB1600") echo "selected"; ?> >NB1600</option>
							<option value="NB2700" <? if ($_SESSION["NM_SYSTEM_TYPE"]=="NB2700") echo "selected"; ?> >NB2700</option>
							<option value="NB3700" <? if ($_SESSION["NM_SYSTEM_TYPE"]=="NB3700") echo "selected"; ?> >NB3700</option>
							<option value="GENERIC" <? if ($_SESSION["NM_SYSTEM_TYPE"]=="GENERIC") echo "selected"; ?> >GENERIC</option>
						</select>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("System Serial Number")?>:</td>
					<td class="c2_right">
						<input type="text" name="serial" id="serial" value="<?=htmlspecialchars($_SESSION["NM_SYSTEM_SERIAL"], ENT_QUOTES, 'UTF-8'); ?>" size=60 <? if ($_SESSION["NM_SYSTEM_TYPE"]=="GENERIC") echo "disabled"; ?>/>
					</td>
				</tr>
				<tr>
					<td class="c2_left"><?= _("Description")?>:</td>
					<td class="c2_right">
						<input type="text" name="description" value="<?=htmlspecialchars($_SESSION["NM_DESCRIPTION"], ENT_QUOTES, 'UTF-8'); ?>" size=60/>
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Use 1:1 NAT")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="nat" id="nat" value="1" <? if ($_SESSION["NM_NAT"]) echo "checked"; if ($_SESSION["NM_SYSTEM_TYPE"]=="GENERIC") echo "disabled"; ?>/>
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Redirect Gateway")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="redirectgateway" id="redirectgateway" value="1" <? if ($_SESSION["NM_REDIRECT_GATEWAY"]) echo "checked"; ?> <?=($_SESSION["NM_VPN_TYPE"]=="openvpn") ? $maxClientDisable : "disabled"; ?> />
					</td>
				</tr>
			</table>
			<br /><? vp_display_status(); ?>
			<br />
			<div id="cnt_right_bottom">
				<input type="submit" name="Add" value="<?=_("Add")?>" <?=$maxClientDisable ?> />
			</div>
		</form>
	</div>
</div> 

<? require_once("footer.php") ?>

