<?
$SECTION=4;
$PAGE=1;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if (isset($_POST["Delete"])) {
	$_SESSION['NM_STA_USERNAME'] = $_POST["username"];
	$query = "DELETE FROM L2tpIpsecClients WHERE Username=:username";
	$stmt = $cfg->pdb->prepare($query);
	$res = $stmt->execute(array(':username' => $_SESSION['NM_STA_USERNAME']));
	if ((!$res) || ($stmt->rowCount()==0))
	{
		vp_error("Could not delete station!");
	} else {
		exec("sudo /usr/lib/vpnportal/action/modify-l2tpipsec", $output, $res);
	}
} elseif (isset($_POST["Add"])) {
	$_SESSION['NM_STA_USERNAME'] = trim($_POST["username"]);
	$_SESSION["NM_STA_PASSWORD"] = trim($_POST["password"]);
	$_SESSION["NM_STA_IP_ADDRESS"] = trim($_POST["ip-address"]);
	$_SESSION["NM_STA_DESCRIPTION"] = $_POST["description"];

	if (strlen($_SESSION['NM_STA_USERNAME'])==0)
	{
		vp_error("Username is empty!");
	} else {
		$usr = $_SESSION['NM_STA_USERNAME'];
		$query = "SELECT COUNT(*) FROM L2tpIpsecClients WHERE Username=:usr";
		$stmt = $cfg->pdb->prepare($query);
		$stmt->execute(array(':usr' => $usr));
		$res = $stmt->fetchColumn();
		if ($res>0)
		{
			vp_error("Username already in use!");
		}
	}

	if (strlen($_SESSION['NM_STA_PASSWORD'])==0)
	{
		vp_error("Password is empty!");
	}

	if (valid_address($_SESSION['NM_STA_IP_ADDRESS'])==0)
	{
		vp_error("Invalid station IP address!");
	} else {
		$addr = $_SESSION['NM_STA_IP_ADDRESS'];
		$query = "SELECT Username FROM L2tpIpsecClients WHERE V4ClientAddress=:addr";
		$stmt = $cfg->pdb->prepare($query);
		$stmt->execute(array(':addr' => $addr));
		$row = $stmt->fetch(PDO::FETCH_ASSOC);
		if ($row)
		{
			$usr=$row['Username'];
			vp_error("IP Address already in use by ". htmlspecialchars($usr, ENT_QUOTES, 'UTF-8') . "!");
		}
		
		$query = "SELECT * FROM L2tpIpsecSettings";
		$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
		$start = $res['V4LeaseStartAddress'];
		$end = $res['V4LeaseEndAddress'];

		if ((ip2long($addr)<ip2long($start)) ||
				(ip2long($addr)>ip2long($end)))
		{
			vp_error("IP address is in wrong network!");
		}
	}
	
	if (!vp_is_error()) {
		$query = "INSERT INTO L2tpIpsecClients " .
				"(Username, Password, V4ClientAddress, Description) VALUES" .
				"(:username," .
				":password," .
				":ipaddress," .
				":description)";
		$stmt = $cfg->pdb->prepare($query);
		$res = $stmt->execute(array(':username' => $_SESSION['NM_STA_USERNAME'],
																':password' => $_SESSION['NM_STA_PASSWORD'],
																':ipaddress' => $_SESSION["NM_STA_IP_ADDRESS"],
																':description' => $_SESSION["NM_STA_DESCRIPTION"],
												));
		if ($res)
		{
			exec("sudo /usr/lib/vpnportal/action/modify-l2tpipsec", $output, $res);
		} else {
			vp_error("Could not insert station!");
		}
	}
}

if (!isset($_POST["Add"])) {
	$_SESSION["NM_STA_USERNAME"] = "";
	$_SESSION["NM_STA_PASSWORD"] = "";
	$_SESSION["NM_STA_IP_ADDRESS"] = "";
	$_SESSION["NM_STA_DESCRIPTION"] = "";
}

$query = "SELECT * FROM L2tpIpsecClients ORDER BY Username ASC";
$clients = $cfg->pdb->query($query)->fetchAll();

$l2tpipsec_connected_file="/tmp/vpnportal/l2tpipsec_clients/connected";
if (file_exists($l2tpipsec_connected_file))
{
	$f=fopen($l2tpipsec_connected_file,"r");
	if ($f)
	{
		while ($client=fgets($f))
		{
		  $params = explode(" ", $client);
		  
		  $vpnIp=trim($params[0]);
		  $internetIp[$vpnIp]=trim($params[1]);
		}
		fclose($f);
	}
}

// find free IP addresses

$query = "SELECT V4LeaseStartAddress, V4LeaseEndAddress FROM L2tpIpsecSettings";
$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
$leaseStart=ip2long($res['V4LeaseStartAddress']);
$leaseEnd=ip2long($res['V4LeaseEndAddress']);
$leaseEnd = ($leaseEnd-$leaseStart > $maxRemoteStations) ? $leaseStart + $maxRemoteStations -1 : $leaseEnd;

$client_ips = Array();

for ($lease=$leaseStart; $lease<=$leaseEnd; $lease++)
{
	$addr=long2ip($lease);
	$stmt = $cfg->pdb->prepare("SELECT COUNT(*) FROM L2tpIpsecClients WHERE V4ClientAddress=:addr");
	$stmt->execute(array(':addr' => $addr));
	$count = $stmt->fetchColumn();
	if ($count==0)
		array_push($client_ips, $addr);	
}

if (count($client_ips)==0)
{
	vp_error("Maximum number of clients reached!");
	$maxClientDisable="disabled";
} else {
	$maxClientDisable="";
}

?>

<div class="item">
	<div class="content_top">
		<h1>Control Stations</h1>
		<br />
		<h2>Stations</h2>
		<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<br />
<? if (count($clients)>0) { ?>
		<table width="60%">
			<tr>
				<th class="c2_left"><?= _("Username")?></th>
				<th class="c2_left"><?= _("VPN IP Address")?></th>
				<th class="c2_left"><?= _("Connected")?></th>
				<th class="c2_left"><?= _("Description")?></th>
				<th class="c2_left"></th>
			</tr>
			<tr>
<?
	$i=0;
	while ($i<count($clients))
	{
		$row = $clients[$i];
		$username = $row['Username'];
		$password = $row['Password'];
		$ipaddress = $row['V4ClientAddress'];
		$description = (isset($row['Description'])) ? $row['Description'] : "";
		$scriptname=$_SERVER["SCRIPT_NAME"];
		echo "<tr><td>". htmlspecialchars($username, ENT_QUOTES, 'UTF-8') . "</td><td>" . htmlspecialchars($ipaddress, ENT_QUOTES, 'UTF-8') . "</td><td>\n";
		if (isset($internetIp[$ipaddress]))
		{
			echo "<font color=\"green\">Yes</font>";
		} else {
			echo "<font color=\"red\">No</font>";
		}
		echo "</td><td>" . htmlspecialchars($description, ENT_QUOTES, 'UTF-8') . "</td><td><form method=\"post\" action=\"$scriptname\" name=\"" . htmlspecialchars($username, ENT_QUOTES, 'UTF-8') . "\">\n";
		echo "<input type=\"submit\" name=\"Delete\" value=\"Delete\" />\n";
		echo "<input type=\"hidden\" name=\"username\" value=\"" . htmlspecialchars($username, ENT_QUOTES, 'UTF-8') . "\" />\n";
		echo "</form></td><tr />\n";
		$i++;
	}
?>
			</tr>
		</table>
<? } ?>
		<br /><br />

		<h2>Add Station</h2>
		<br />
		<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form3">
			<table width="70%">
				<tr>
					<th class="c2_left"><?= _("Username")?></th>
					<th class="c2_left"><?= _("Password")?></th>
					<th class="c2_left"><?= _("VPN IP Address")?></th>
					<th class="c2_left"><?= _("Description")?></th>
				</tr>
				<tr>
					<td class="c2_left"><input type="text" name="username" value="<?=htmlspecialchars($_SESSION["NM_STA_USERNAME"], ENT_QUOTES, 'UTF-8') ?>" /></td>
					<td class="c2_left"><input type="text" name="password" value="<?=htmlspecialchars($_SESSION["NM_STA_PASSWORD"], ENT_QUOTES, 'UTF-8') ?>" /></td>

						<td class="c2_left"><select name="ip-address" <?=$maxClientDisable ?>>
<? foreach ($client_ips as $ip) { ?>
							<option value="<?=$ip ?>" <? if ($_SESSION["NM_STA_IP_ADDRESS"]==$ip) echo "selected"; ?> ><?=$ip ?></option>
<? } ?>
						</select></td>
					<td class="c2_left"><input type="text" name="description" value="<?=htmlspecialchars($_SESSION["NM_STA_DESCRIPTION"], ENT_QUOTES, 'UTF-8') ?>" /></td>
				</tr>
			</table>
			<br />
<? if (isset($_POST["Add"])) { ?>
			<? vp_display_status(); ?>
<? } ?>
			<br />
			<div id="cnt_right_bottom_2">
				<input type="submit" name="Add" value="<?=_("Add")?>" <?=$maxClientDisable ?> />
			</div>
		</form>

 </div>
</div> 


<? require_once("footer.php") ?>
