<?
$SECTION=6;
$PAGE=2;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if ($_SESSION['NM_CUR_USERNAME']!="admin")
{
	header('Location: login.php');
	exit;
}

$asConfigured=$cfg->getStage()>=Config::STAGE_AUTOSETUP_CONFIGURED;
$asConfiguredDisable=($asConfigured) ? "disabled" : "";

if (isset($_POST["Apply"])) {
	if ($asConfigured)
	{
		$query = "SELECT * FROM MobileipSettings";
		$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
		$_SESSION['NM_ENABLED'] = $res['Enabled'];
		$_SESSION['NM_NETWORK_ADDRESS'] = $res['V4NetworkAddress'];
		$_SESSION["NM_NETWORK_MASK"] = $res['V4NetworkMask'];
	} else {
		$_SESSION['NM_ENABLED'] = (isset($_POST["enabled"])) ? $_POST["enabled"] : "0";
		$_SESSION['NM_NETWORK_ADDRESS'] = $_POST["network-address"];
		$_SESSION["NM_NETWORK_MASK"] = $_POST["network-mask"];
	}
	$_SESSION["NM_NAT"] = (isset($_POST["nat"])) ? $_POST["nat"] : "0";
	$_SESSION["NM_REDIRECTGATEWAY"] = (isset($_POST["redirectgateway"])) ? $_POST["redirectgateway"] : "0";

	if (!$asConfigured)
	{
		if (!valid_network($_SESSION['NM_NETWORK_ADDRESS'], $_SESSION['NM_NETWORK_MASK'])) {
			vp_error("Invalid network address/mask pair!");
		}
	}
	
	if (!vp_is_error()) {
		if ($asConfigured)
		{
			$query = "UPDATE MobileipSettings SET " .
					"DefaultNat=:nat," .
					"DefaultRedirectGateway=:redirectgateway";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':nat' => $_SESSION["NM_NAT"],
														':redirectgateway' => $_SESSION["NM_REDIRECTGATEWAY"],
										));
		} else {
			$query = "UPDATE MobileipSettings SET " .
					"Enabled=:enabled," .
					"V4NetworkAddress=:networkaddress," .
					"V4NetworkMask=:networkmask," .
					"DefaultNat=:nat," .
					"DefaultRedirectGateway=:redirectgateway";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':enabled' => $_SESSION['NM_ENABLED'],
														':networkaddress' => $_SESSION['NM_NETWORK_ADDRESS'],
														':networkmask' => $_SESSION["NM_NETWORK_MASK"],
														':nat' => $_SESSION["NM_NAT"],
														':redirectgateway' => $_SESSION["NM_REDIRECTGATEWAY"]
										));
			exec("sudo /usr/lib/vpnportal/action/modify-mobileip restart", $output, $res);
			if ($res!=0)
			{
				vp_error("Could not modify openvpn settings!");
			}
		}
	}
} else {
	$query = "SELECT * FROM MobileipSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
	$_SESSION['NM_ENABLED'] = $res['Enabled'];
	$_SESSION['NM_NETWORK_ADDRESS'] = $res['V4NetworkAddress'];
	$_SESSION["NM_NETWORK_MASK"] = $res['V4NetworkMask'];
	$_SESSION["NM_NAT"] = $res['DefaultNat'];
	$_SESSION["NM_REDIRECTGATEWAY"] = $res['DefaultRedirectGateway'];
}

$nets=$cfg->getAvailableNetworks($_SESSION['NM_NETWORK_ADDRESS']);
?>

<div class="item">
	<div class="content_top">
		<h1>Server</h1>
		<br />
		<h2>Mobile IP</h2>
		<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
	<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
		<table>
			<tr>
				<td class="c2_left">
					<?=_("Enabled")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="enabled" value="1" <?=($_SESSION['NM_ENABLED'] == "1") ? 'checked' : '' ?> <?=$asConfiguredDisable ?> />
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Network Address")?>:</td>
				<td class="c2_right">
					<select name="network-address" <?=$asConfiguredDisable ?>>
<? foreach ($nets as $net) { ?>
						<option value="<?=$net ?>" <? if ($_SESSION['NM_NETWORK_ADDRESS'] == $net) echo 'selected'; ?>><?=$net ?></option>
<? } ?>
					</select>
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Network Mask")?>:</td>
				<td class="c2_right">
					<input type="text" name="network-mask" value="<?=htmlspecialchars($_SESSION["NM_NETWORK_MASK"], ENT_QUOTES, 'UTF-8');?>" size=60 disabled />
					<input type="hidden" name="network-mask" value="<?=htmlspecialchars($_SESSION["NM_NETWORK_MASK"], ENT_QUOTES, 'UTF-8');?>" size=60 />
				</td>
			</tr>
			<tr>
				<td colspan=2><br /><?=_("Client Defaults")?>:<br /><br /></td>
			</tr>
			<tr>
				<td class="c2_left">
					<?=_("Use 1:1 NAT")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="nat" value="1" <?=($_SESSION['NM_NAT'] == "1") ? 'checked' : '' ?> />
				</td>
			</tr>
<!--
			<tr>
				<td class="c2_left">
					<?=_("Redirect Gateway")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="redirectgateway" value="1" <?=($_SESSION['NM_REDIRECTGATEWAY'] == "1") ? 'checked' : '' ?> />
				</td>
			</tr>
-->
			</table>
			<br /><? vp_display_status(); ?>
			<br />
			<div id="cnt_right_bottom">
				<input type="submit" name="Apply" value="<?=_("Apply")?>" />
			</div>
		</form>
 </div>
</div> 


<? require_once("footer.php") ?>
