<?
$SECTION=6;
$PAGE=1;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if ($_SESSION['NM_CUR_USERNAME']!="admin")
{
	header('Location: login.php');
	exit;
}

$asConfigured=$cfg->getStage()>=Config::STAGE_AUTOSETUP_CONFIGURED;
$asConfiguredDisable=($asConfigured) ? "disabled" : "";

if (isset($_POST["Apply"])) {
	if ($asConfigured)
	{
		$query = "SELECT * FROM OpenvpnSettings";
		$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
		$_SESSION['NM_ENABLED'] = $res['Enabled'];
		$_SESSION['NM_LISTENING_PORT'] = $res['ListeningPort'];
		$_SESSION['NM_PROTOCOL'] = $res['Protocol'];
		$_SESSION['NM_CIPHER'] = $res['Cipher'];
		$_SESSION["NM_HASH"] = $res['Hash'];
		$_SESSION['NM_COMPRESSION'] = $res['Compression'];
		$_SESSION["NM_KEEPALIVE"] = $res['Keepalive'];
		$_SESSION['NM_NETWORK_ADDRESS'] = $res['V4NetworkAddress'];
		$_SESSION["NM_NETWORK_MASK"] = $res['V4NetworkMask'];
	} else {
		$_SESSION['NM_ENABLED'] = (isset($_POST["enabled"])) ? $_POST["enabled"] : "0";
		$_SESSION['NM_LISTENING_PORT'] = $_POST["listening-port"];
		$_SESSION['NM_PROTOCOL'] = $_POST["protocol"];
		$_SESSION['NM_CIPHER'] = $_POST["cipher"];
		$_SESSION["NM_HASH"] = $_POST["hash"];
		$_SESSION['NM_COMPRESSION'] = (isset($_POST["compression"])) ? $_POST["compression"] : "0";
		$_SESSION["NM_KEEPALIVE"] = (isset($_POST["keepalive"])) ? $_POST["keepalive"] : "0";
		$_SESSION['NM_NETWORK_ADDRESS'] = $_POST["network-address"];
		$_SESSION["NM_NETWORK_MASK"] = $_POST["network-mask"];
	}
	$_SESSION["NM_NAT"] = (isset($_POST["nat"])) ? $_POST["nat"] : "0";
	$_SESSION["NM_REDIRECTGATEWAY"] = (isset($_POST["redirectgateway"])) ? $_POST["redirectgateway"] : "0";

	if (!$asConfigured)
	{
		if (!valid_port($_SESSION['NM_LISTENING_PORT'])) {
			vp_error("Invalid listening port!");
		}

		if (!valid_network($_SESSION['NM_NETWORK_ADDRESS'], $_SESSION['NM_NETWORK_MASK'])) {
			vp_error("Invalid network address/mask pair!");
		}
	}
	
	if (!vp_is_error()) {
		if ($asConfigured)
		{
			$query = "UPDATE OpenvpnSettings SET " .
					"DefaultNat=:defaultnat," .
					"DefaultRedirectGateway=:defaultredirectgateway";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':defaultnat' => $_SESSION["NM_NAT"],
										':defaultredirectgateway' => $_SESSION["NM_REDIRECTGATEWAY"]
										));
		} else {
			$query = "UPDATE OpenvpnSettings SET " .
					"Enabled=:enabled," .
					"ListeningPort=:listeningport," .
					"Protocol=:protocol," .
					"Cipher=:clipher," .
					"Hash=:hash," .
					"Compression=:compression," .
					"Keepalive=:keepalive," .
					"V4NetworkAddress=:networkaddress," .
					"V4NetworkMask=:networkmask," .
					"DefaultNat=:defaultnat," .
					"DefaultRedirectGateway=:defaultredirectgateway";

				$stmt = $cfg->pdb->prepare($query);
				$stmt->execute(array(':enabled' => $_SESSION['NM_ENABLED'],
														':listeningport' => $_SESSION['NM_LISTENING_PORT'],
														':protocol' => $_SESSION['NM_PROTOCOL'],
														':clipher' => $_SESSION['NM_CIPHER'],
														':hash' => $_SESSION["NM_HASH"],
														':compression' => $_SESSION['NM_COMPRESSION'],
														':keepalive' => $_SESSION["NM_KEEPALIVE"],
														':networkaddress' => $_SESSION['NM_NETWORK_ADDRESS'],
														':networkmask' => $_SESSION["NM_NETWORK_MASK"],
														':defaultnat' => $_SESSION["NM_NAT"],
														':defaultredirectgateway' => $_SESSION["NM_REDIRECTGATEWAY"]
											));
			exec("sudo /usr/lib/vpnportal/action/modify-openvpn", $output, $res);
			if ($res!=0)
			{
				vp_error("Could not modify openvpn settings!");
			}
		}
	}
} else {
	$query = "SELECT * FROM OpenvpnSettings";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
	$_SESSION['NM_ENABLED'] = $res['Enabled'];
	$_SESSION['NM_LISTENING_PORT'] = $res['ListeningPort'];
	$_SESSION['NM_PROTOCOL'] = $res['Protocol'];
	$_SESSION['NM_CIPHER'] = $res['Cipher'];
	$_SESSION["NM_HASH"] = $res['Hash'];
	$_SESSION['NM_COMPRESSION'] = $res['Compression'];
	$_SESSION["NM_KEEPALIVE"] = $res['Keepalive'];
	$_SESSION['NM_NETWORK_ADDRESS'] = $res['V4NetworkAddress'];
	$_SESSION["NM_NETWORK_MASK"] = $res['V4NetworkMask'];
	$_SESSION["NM_NAT"] = $res['DefaultNat'];
	$_SESSION["NM_REDIRECTGATEWAY"] = $res['DefaultRedirectGateway'];
}

$nets=$cfg->getAvailableNetworks($_SESSION['NM_NETWORK_ADDRESS']);
?>

<div class="item">
	<div class="content_top">
		<h1>Server</h1>
		<br />
		<h2>OpenVPN</h2>
		<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
	<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
		<table>
			<tr>
				<td class="c2_left">
					<?=_("Enabled")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="enabled" value="1" <?=($_SESSION['NM_ENABLED'] == "1") ? 'checked' : '' ?> <?=$asConfiguredDisable ?> />
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Transport Protocol")?>:</td>
				<td class="c2_right">
					<select name="protocol" <?=(isMcrActive()) ? "disabled" : $asConfiguredDisable ?>>
						<option value="udp" <? if ($_SESSION['NM_PROTOCOL'] == "udp") echo 'selected'; ?>>UDP</option>
						<option value="tcp" <? if ($_SESSION['NM_PROTOCOL'] == "tcp") echo 'selected'; ?>>TCP</option>
					</select>
					<? if (isMcrActive()) { ?>
					<input type="hidden" name="protocol" value="<?=htmlspecialchars($_SESSION['NM_PROTOCOL'], ENT_QUOTES, 'UTF-8');?>" size=60 />
					<? } ?>
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Listening Port")?>:</td>
				<td class="c2_right">
					<input type="text" name="listening-port" value="<?=htmlspecialchars($_SESSION["NM_LISTENING_PORT"], ENT_QUOTES, 'UTF-8');?>" size=60 <?=(isMcrActive()) ? "disabled" : $asConfiguredDisable ?> />
					<? if (isMcrActive()) { ?>
					<input type="hidden" name="listening-port" value="<?=htmlspecialchars($_SESSION["NM_LISTENING_PORT"], ENT_QUOTES, 'UTF-8');?>" size=60 />
					<? } ?>
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Network Address")?>:</td>
				<td class="c2_right">
					<select name="network-address" <?=$asConfiguredDisable ?>>
<? foreach ($nets as $net) { ?>
						<option value="<?=$net ?>" <? if ($_SESSION['NM_NETWORK_ADDRESS'] == $net) echo 'selected'; ?>><?=$net ?></option>
<? } ?>
					</select>
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Network Mask")?>:</td>
				<td class="c2_right">
					<input type="text" name="network-mask" value="<?=htmlspecialchars($_SESSION["NM_NETWORK_MASK"], ENT_QUOTES, 'UTF-8');?>" size=60 disabled />
					<input type="hidden" name="network-mask" value="<?=htmlspecialchars($_SESSION["NM_NETWORK_MASK"], ENT_QUOTES, 'UTF-8');?>" size=60 />
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Cipher Algorithm")?>:</td>
				<td class="c2_right">
					<select name="cipher" <?=$asConfiguredDisable ?>>
						<option value="BF-CBC" <? if ($_SESSION['NM_CIPHER'] == "BF-CBC") echo 'selected'; ?>>BF-CBC</option>
						<option value="AES-128-CBC" <? if ($_SESSION['NM_CIPHER'] == "AES-128-CBC") echo 'selected'; ?>>AES-128-CBC</option>
						<option value="AES-192-CBC" <? if ($_SESSION['NM_CIPHER'] == "AES-192-CBC") echo 'selected'; ?>>AES-192-CBC</option>
						<option value="AES-256-CBC" <? if ($_SESSION['NM_CIPHER'] == "AES-256-CBC") echo 'selected'; ?>>AES-256-CBC</option>
						<option value="RC2-CBC" <? if ($_SESSION['NM_CIPHER'] == "RC2-CBC") echo 'selected'; ?>>RC2-CBC</option>
						<option value="DES-CBC" <? if ($_SESSION['NM_CIPHER'] == "DES-CBC") echo 'selected'; ?>>DES-CBC</option>
						<option value="DES-EDE3-CBC" <? if ($_SESSION['NM_CIPHER'] == "DES-EDE3-CBC") echo 'selected'; ?>>DES-EDE3-CBC</option>
					</select>
				</td>
			</tr>
			<tr>
				<td class="c2_left"><?= _("Hash Algorithm")?>:</td>
				<td class="c2_right">
					<select name="hash" <?=$asConfiguredDisable ?>>
						<option value="SHA224" <? if ($_SESSION['NM_HASH'] == "SHA224") echo 'selected'; ?>>SHA224</option>
						<option value="SHA256" <? if ($_SESSION['NM_HASH'] == "SHA256") echo 'selected'; ?>>SHA256</option>
						<option value="SHA384" <? if ($_SESSION['NM_HASH'] == "SHA384") echo 'selected'; ?>>SHA384</option>
						<option value="SHA512" <? if ($_SESSION['NM_HASH'] == "SHA512") echo 'selected'; ?>>SHA512</option>
						<option value="SHA1" <? if ($_SESSION['NM_HASH'] == "SHA1") echo 'selected'; ?>>SHA1</option>
						<option value="MD5" <? if ($_SESSION['NM_HASH'] == "MD5") echo 'selected'; ?>>MD5</option>
					</select>
				</td>
			</tr>
			<tr>
				<td class="c2_left">
					<?=_("Enable Compression")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="compression" value="1" <?=($_SESSION['NM_COMPRESSION'] == "1") ? 'checked' : '' ?> <?=$asConfiguredDisable ?> />
				</td>
			</tr>
			<tr>
				<td class="c2_left">
					<?=_("Enable Keepalive")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="keepalive" value="1" <?=($_SESSION['NM_KEEPALIVE'] == "1") ? 'checked' : '' ?> <?=$asConfiguredDisable ?> />
				</td>
			</tr>
			<tr>
				<td colspan=2><br /><?=_("Client Defaults")?>:<br /><br /></td>
			</tr>
			<tr>
				<td class="c2_left">
					<?=_("Use 1:1 NAT")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="nat" value="1" <?=($_SESSION['NM_NAT'] == "1") ? 'checked' : '' ?> />
				</td>
			</tr>
			<tr>
				<td class="c2_left">
					<?=_("Redirect Gateway")?>:
				</td>
				<td class="c2_right">
					<input type="checkbox" name="redirectgateway" value="1" <?=($_SESSION['NM_REDIRECTGATEWAY'] == "1") ? 'checked' : '' ?> />
				</td>
			</tr>
			</table>
			<br /><? vp_display_status(); ?>
			<br />
			<div id="cnt_right_bottom">
				<input type="submit" name="Apply" value="<?=_("Apply")?>" />
			</div>
		</form>
 </div>
</div> 


<? require_once("footer.php") ?>
