<?
$SECTION=6;
$PAGE=4;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

if ($_SESSION['NM_CUR_USERNAME']!="admin")
{
	header('Location: login.php');
	exit;
}

$MCR_ENABLED=is_dir("/etc/mcrinfo");

/*
 * get available interfaces 
 */
function get_interfaces()
{
	$interfaces = Array();

	$cmd = "ip link show | " .
					"grep '^[0-9]' | " .
					"awk -F':' '{ print $2; }'";

	array_push($interfaces, "none");
	exec($cmd , $output, $ret);
	foreach ($output as $line) {
		$line=trim($line);
		if (strpos($line, "lo")===0) continue;
		if (strpos($line, "pan")===0) continue;
		if (strpos($line, "tun")===0) continue;
		if (strpos($line, "mip")===0) continue;
		array_push($interfaces, $line);
	}
	return $interfaces;
}

$asConfiguredDisableBool=($cfg->getStage()>=Config::STAGE_AUTOSETUP_CONFIGURED);
$asConfiguredDisableStr=($asConfiguredDisableBool) ? "disabled" : "";
$asConfiguredDisableMcrBool=(($cfg->getStage()>=Config::STAGE_AUTOSETUP_CONFIGURED) || ($MCR_ENABLED));
$asConfiguredDisableMcrStr=($asConfiguredDisableMcrBool) ? "disabled" : "";
$readFromDB=0;

if (isset($_POST["Apply"])) {
	if (!$asConfiguredDisableBool)
	{
		$_SESSION["NM_SERVER_INTERFACE"] = $_POST["server-interface"];
		$_SESSION["NM_HOSTNAME"] = trim($_POST["hostname"]);
		$_SESSION["NM_SERVER_ADDRESS"] = $_POST["server-address"];
		$_SESSION["NM_SERVER_NETMASK"] = $_POST["server-netmask"];
		$_SESSION["NM_DEFAULT_GATEWAY"] = $_POST["default-gateway"];
		$_SESSION["NM_NAMESERVER0"] = $_POST["nameserver0"];
		$_SESSION["NM_NAMESERVER1"] = $_POST["nameserver1"];
	}
	$_SESSION["NM_VPN_INTERNET_ACCESS"] = isset($_POST["vpn-internet-access"]) ? 1 : 0;


	if (!$asConfiguredDisableBool)
	{
		if ($_POST["server-address"] == "" ||
			!valid_address($_POST["server-address"])) {
			vp_error("Invalid server address.");
		}
		
		if ($_POST["server-netmask"] == "" ||
			!valid_netmask($_POST["server-netmask"])) {
			vp_error("Invalid server netmask!");
		}
	
		if ($_POST["default-gateway"] == "" ||
			!valid_address($_POST["default-gateway"])) {
			vp_error("Invalid default gateway!");
		}
	
		if ($_POST["nameserver0"] == "" ||
			!valid_address($_POST["nameserver0"])) {
			vp_error("Invalid nameserver!");
		}

		if (isset($_POST["nameserver1"]))
		{
			if (strlen($_POST["nameserver1"]))
			{
				if ($_POST["nameserver1"] == "" ||
					!valid_address($_POST["nameserver1"])) {
					vp_error("Invalid nameserver!");
				}
			}
		}
	}

	if (!vp_is_error())
	{
		if (!$asConfiguredDisableBool)
		{
			$query = "UPDATE ServerInternetAccess SET " .
				"Hostname=:hostname," .
				"Interface=:interface," .
				"V4Address=:v4address," .
				"V4Netmask=:v4netmask," .
				"V4Gateway=:v4gateway," .
				"V4Dns0=:v4dns0," .
				"V4Dns1=:v4dns1," .
				"VpnInternetAccess=:vpninternetaccess";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':hostname' => $_SESSION["NM_HOSTNAME"],
														':interface' => $_SESSION["NM_SERVER_INTERFACE"],
														':v4address' => $_SESSION["NM_SERVER_ADDRESS"],
														':v4netmask' => $_SESSION["NM_SERVER_NETMASK"],
														':v4gateway' => $_SESSION["NM_DEFAULT_GATEWAY"],
														':v4dns0' => $_SESSION["NM_NAMESERVER0"],
														':v4dns1' => $_SESSION["NM_NAMESERVER1"],
														':vpninternetaccess' => $_SESSION["NM_VPN_INTERNET_ACCESS"]
										));
			exec("sudo /usr/lib/vpnportal/ca/genWebServerCert force");
			if ($cfg->getStage()<Config::STAGE_SERVER_CONFIGURED)
			{
				$cfg->setStage(Config::STAGE_SERVER_CONFIGURED);
				header('Location: autosetup-settings.php');
				exit;
			}
		} else {
			$query = "UPDATE ServerInternetAccess SET VpnInternetAccess=:vpninternetaccess";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':vpninternetaccess' => $_SESSION["NM_VPN_INTERNET_ACCESS"]));
			$readFromDB=1;
		}
		exec("sudo service vpnportal restart");
	}
} else if (isset($_POST["Detect"])) {
	$_SESSION["NM_SERVER_INTERFACE"] = $_POST["server-interface"];
	unset($_SESSION["NM_SERVER_ADDRESS"]);
	unset($_SESSION["NM_SERVER_NETMASK"]);
	unset($_SESSION["NM_DEFAULT_GATEWAY"]);
	unset($_SESSION["NM_NAMESERVER0"]);
	unset($_SESSION["NM_NAMESERVER1"]);
	$readFromDB=0;
} else {
	$readFromDB=1;
}

if ($readFromDB) {
	$query = "SELECT * FROM ServerInternetAccess";
	$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
	$_SESSION['NM_HOSTNAME'] = $res['Hostname'];
	$_SESSION['NM_SERVER_INTERFACE'] = $res['Interface'];
	$_SESSION['NM_SERVER_ADDRESS'] = $res['V4Address'];
	$_SESSION["NM_SERVER_NETMASK"] = $res['V4Netmask'];
	$_SESSION['NM_DEFAULT_GATEWAY'] = $res['V4Gateway'];
	$_SESSION["NM_NAMESERVER0"] = $res['V4Dns0'];
	$_SESSION["NM_NAMESERVER1"] = $res['V4Dns1'];
	$_SESSION["NM_VPN_INTERNET_ACCESS"] = $res['VpnInternetAccess'];
}

if ($MCR_ENABLED)
{
	if (strlen($_SESSION['NM_SERVER_INTERFACE'])==0)
	{
		$_SESSION["NM_SERVER_INTERFACE"] = "eth0";
		if (strlen($_SESSION['NM_HOSTNAME'])==0)
		{
			$_SESSION['NM_HOSTNAME'] = trim(file_get_contents("/etc/mcrinfo/host-hostname"));
		}
		unset($_SESSION["NM_SERVER_ADDRESS"]);
		unset($_SESSION["NM_SERVER_NETMASK"]);
		unset($_SESSION["NM_DEFAULT_GATEWAY"]);
		unset($_SESSION["NM_NAMESERVER0"]);
		unset($_SESSION["NM_NAMESERVER1"]);
	}
}

if (!isset($_SESSION["NM_SERVER_INTERFACE"])) {
	$ifs = get_interfaces();
	$_SESSION["NM_SERVER_INTERFACE"] = $ifs[0];
}

if (!isset($_SESSION["NM_HOSTNAME"])) {
	$_SESSION["NM_HOSTNAME"] = "";
}

if (!isset($_SESSION["NM_SERVER_ADDRESS"]) ||
	!isset($_SESSION["NM_SERVER_NETMASK"])) {

	$cmd = "ip address show dev " . escapeshellarg($_SESSION["NM_SERVER_INTERFACE"]) . " primary | grep 'inet ' | awk '{ print $2; }'";
	exec($cmd, $ad);
	if (isset($ad[0]))
		$addr = explode("/", $ad[0]);

	if (isset($addr[0]))
	{
		$_SESSION["NM_SERVER_ADDRESS"] = $addr[0];
	} else {
		$_SESSION["NM_SERVER_ADDRESS"] = "";
	}
	if (isset($addr[1]))
	{
		$_SESSION["NM_SERVER_NETMASK"] = cidr2netmask($addr[1]);
	} else {
		$_SESSION["NM_SERVER_NETMASK"] = "";
	}
}

if (!isset($_SESSION["NM_DEFAULT_GATEWAY"])) {
	$cmd = "ip route show dev " . escapeshellarg($_SESSION["NM_SERVER_INTERFACE"]) . " | grep ^default | awk '{ print $3; }'";
	exec($cmd, $rt);
	if (count($rt))
	{
		$_SESSION["NM_DEFAULT_GATEWAY"] = $rt[0];
	} else {
		$_SESSION["NM_DEFAULT_GATEWAY"] = "";
	}
}

if (!isset($_SESSION["NM_NAMESERVER0"])) {
	$cmd = "grep '^nameserver ' /etc/resolv.conf | head -2 | awk '{ print $2; }'";
	exec($cmd, $ns);
	if (isset($ns[0]))
	{
		$_SESSION["NM_NAMESERVER0"] = $ns[0];
	} else {
		$_SESSION["NM_NAMESERVER0"] = "";
	}
	if (isset($ns[1]))
	{
		$_SESSION["NM_NAMESERVER1"] = $ns[1];
	} else {
		$_SESSION["NM_NAMESERVER1"] = "";
	}
}

if (!isset($_SESSION["NM_VPN_INTERNET_ACCESS"])) {
	$_SESSION["NM_VPN_INTERNET_ACCESS"]=1;
}

$detected=((isset($_SESSION["NM_SERVER_ADDRESS"])) && (strlen($_SESSION["NM_SERVER_ADDRESS"])));
?>

<script type="text/javascript">

function detect(obj) {
	var form = document.createElement("form");
	var ifField = document.createElement("input");
	var submitField = document.createElement("input");
	form.setAttribute("method", "post");
	form.setAttribute("action", "<?=$_SERVER["SCRIPT_NAME"] ?>");

	ifField.setAttribute("type", "text");
	ifField.setAttribute("name", "server-interface");
	ifField.setAttribute("value", obj.value);
	form.appendChild(ifField);

	submitField.setAttribute("type", "text");
	submitField.setAttribute("name", "Detect");
	submitField.setAttribute("value", "Detect");
	form.appendChild(submitField);

	document.body.appendChild(form);
	form.submit();
}

</script>

<div class="item">
	<div class="content_top">
		<h1>Server</h1>
		<br />
		<h2>Internet Access</h2>
		<br />
	</div>
</div> 

<div class="item">
	<div class="content_main">
<? if ($cfg->getStage()<Config::STAGE_SERVER_CONFIGURED) { ?>
<font color="green">Please select the IP interface used by your server to connect to the internet.</font><br /><br />
<? } ?>
		<form method="post" action="<?=$_SERVER["SCRIPT_NAME"]?>" name="form1">
			<table width="70%">
				<tr>
					<td class="c2_left" width="40%"><?= _("Server interface")?>:</td>
					<td class="c2_right" width="60%">
						<select id="server-interface" name="server-interface" onChange="detect(this)" <?=$asConfiguredDisableMcrStr ?>>
<? foreach (get_interfaces() as $ifc) { ?>
							<option value="<?=$ifc?>" <? if($_SESSION['NM_SERVER_INTERFACE'] == $ifc) echo 'selected'; ?>><?=$ifc?></option>
<? } ?>
						</select>
<? if ($asConfiguredDisableMcrBool) { ?>
						<input type="hidden" name="server-interface" value="<?=$_SESSION['NM_SERVER_INTERFACE']?>" />
<? } ?>
					</td>
				</tr>
			</table>
			<br />
			<table width="70%">
				<tr>
					<td class="c2_left"  width="40%">
						<?=_("Server address")?>:
					</td>
					<td class="c2_right"  width="60%">
						<?=htmlspecialchars($_SESSION["NM_SERVER_ADDRESS"], ENT_QUOTES, 'UTF-8')?>
						<input type="hidden" name="server-address" value="<?=htmlspecialchars($_SESSION["NM_SERVER_ADDRESS"], ENT_QUOTES, 'UTF-8')?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Server netmask")?>:
					</td>
					<td class="c2_right">
						<?=htmlspecialchars($_SESSION["NM_SERVER_NETMASK"], ENT_QUOTES, 'UTF-8')?>
						<input type="hidden" name="server-netmask" value="<?=htmlspecialchars($_SESSION["NM_SERVER_NETMASK"], ENT_QUOTES, 'UTF-8')?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Default gateway")?>:
					</td>
					<td class="c2_right">
						<?=htmlspecialchars($_SESSION["NM_DEFAULT_GATEWAY"], ENT_QUOTES, 'UTF-8')?>
						<input type="hidden" name="default-gateway" value="<?=htmlspecialchars($_SESSION["NM_DEFAULT_GATEWAY"], ENT_QUOTES, 'UTF-8')?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Nameserver 1")?>:
					</td>
					<td class="c2_right">
						<?=htmlspecialchars($_SESSION["NM_NAMESERVER0"], ENT_QUOTES, 'UTF-8')?>
						<input type="hidden" name="nameserver0" value="<?=htmlspecialchars($_SESSION["NM_NAMESERVER0"], ENT_QUOTES, 'UTF-8')?>" />
					</td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Nameserver 2")?>:
					</td>
					<td class="c2_right">
						<?=htmlspecialchars($_SESSION["NM_NAMESERVER1"], ENT_QUOTES, 'UTF-8')?>
						<input type="hidden" name="nameserver1" value="<?=htmlspecialchars($_SESSION["NM_NAMESERVER1"], ENT_QUOTES, 'UTF-8')?>" />
					</td>
				</tr>
				<tr>
					<td colspan=2><br /> </td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Public server FQDN or address")?>:
					</td>
					<td class="c2_right">
						<input type="text" name="hostname" id="hostname" value="<?=htmlspecialchars($_SESSION["NM_HOSTNAME"], ENT_QUOTES, 'UTF-8')?>" size=40 <?=($detected) ? "$asConfiguredDisableStr" : "disabled" ?> />
<? if ($asConfiguredDisableBool) { ?>
						<input type="hidden" name="hostname" value="<?=htmlspecialchars($_SESSION["NM_HOSTNAME"], ENT_QUOTES, 'UTF-8')?>" />
<? } ?>
					</td>
				</tr>
				<tr>
					<td class="c2_left"></td>
					<td class="c2_right">
						(Use FQDN, if the server has a DNS name or an IP address different from the server address, if the server is behind a NAT. Otherwise leave it empty.)
					</td>
				</tr>
				<tr>
					<td colspan=2><br /> </td>
				</tr>
				<tr>
					<td class="c2_left">
						<?=_("Allow internet access from VPN")?>:
					</td>
					<td class="c2_right">
						<input type="checkbox" name="vpn-internet-access" value="1" <? if ($_SESSION['NM_VPN_INTERNET_ACCESS'] == "1") echo 'checked'; ?> />
					</td>
				</tr>
			</table>
			<br /><?  vp_display_status(); ?>
			<div id="cnt_right_bottom">
				<input type="submit" id="apply" name="Apply" value="<?=_("Apply")?>" <?=($detected) ? "" : "disabled" ?> />
			</div>
		</form>
		<? if (($cfg->getStage()>=Config::STAGE_SERVER_CONFIGURED) && (!vp_is_error())) { ?>
		<br /><br />
		<form name="form1" METHOD="post" action="server-webca-cert-file.php">
			<h3>Web server CA certificate</h3>
			<font color="green">You can add this web server CA certificate to your web browser to trust<br />
				the certificate presented by the web server.</font><br /><br />
			<table>
				<tr>
					<td>Web server CA certificate:</td>
					<td class=c2_right>
						<input type="submit" value="Download" name="CaCert"/>
					</td>
				</tr>
			</table>
			<br />
		</form>
		<? } ?>
	</div>
</div> 

<? require_once("footer.php") ?>
