<?

	function makeSeed()
	{
		list($usec, $sec) = explode(' ', microtime());
		return (float) $sec + ((float) $usec * 100000);
	}

	function addClient($cfg, &$err, &$clientName, &$clientIpAddress, 
										&$routedNetAddress, &$routedNetNetworkMask)
	{
		// check, if we have already an entry for that serial in DB
		$serial=$_POST['serial'];
		$type=$_POST['type'];
		$protocol=$_POST['protocol'];
		$description=$_POST['description'];

		if (strlen($serial))
		{
			$query = "SELECT ClientName	FROM VpnClients WHERE SystemSerialNumber=:serial";
			$stmt = $cfg->pdb->prepare($query);
			$stmt->execute(array(':serial' => $serial));
			$res = $stmt->fetch(PDO::FETCH_ASSOC);
			$oldClientName=$res['ClientName'];

			if (strlen($oldClientName))
			{
				// client is already in DB -> delete it
				exec("sudo /usr/lib/vpnportal/action/delete-vpn-client $oldClientName");
			}
		}

		// get network addresses
		if ($protocol=="openvpn")
		{
			$query = "SELECT V4NetworkAddress, V4NetworkMask FROM OpenvpnSettings";
			$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
			$networkAddress=$res['V4NetworkAddress'];
			$networkAddress=explode(".", $networkAddress);
			$networkMask=$res['V4NetworkMask'];
			$networkMask=explode(".", $networkMask);
		} else {
			$query = "SELECT V4NetworkAddress, V4NetworkMask FROM MobileipSettings";
			$res = $cfg->pdb->query($query)->fetch(PDO::FETCH_ASSOC);
			$networkAddress=$res['V4NetworkAddress'];
			$networkAddress=explode(".", $networkAddress);
			$networkMask=$res['V4NetworkMask'];
			$networkMask=explode(".", $networkMask);
		}

		// get client id
		$clientNum=$_POST['client-id'];
		$clientName="CLIENT_" . $clientNum;

		// create new entry for client
		$clientIpAddress=$networkAddress[0] . "." . $networkAddress[1] .
											 "." . $clientNum . "." . "1";
		if (isset($_POST['nat']))
		{
			$nat=1;
			$routedNetAddress=$networkAddress[0] . "." . $networkAddress[1] .
												 "." . $clientNum . "." . "0";
		} else {
			$nat=0;
			$routedNetAddress=$networkAddress[0] . "." . ($networkAddress[1]+1) .
												 "." . $clientNum . "." . "0";
		}
		if (isset($_POST['redirectgateway']))
		{
			$redirectGateway=1;
		} else {
			$redirectGateway=0;
		}
		$routedNetNetworkMask="255.255.255.0";
		if ($protocol=="openvpn") {
			$query = "INSERT INTO VpnClients (ClientName, SystemSerialNumber, SystemType, "
							. "Description, Protocol, Nat, RedirectGateway, V4ClientAddress, "
							. "V4NetworkAddress, V4NetworkNetmask) VALUES (:clientname, "
							. ":serial, :type, :description, :protocol, :nat, "
							. ":redirectgateway, :clientipaddress, :routednetaddress, "
							. ":routednetnetworkmask)";
			$stmt = $cfg->pdb->prepare($query);
			$res = $stmt->execute(array(':clientname' => $clientName,
																	':serial' => $serial,
																	':type' => $type,
																	':description' => $description,
																	':protocol' => $protocol,
																	':nat' => $nat,
																	':redirectgateway' => $redirectGateway,
																	':clientipaddress' => $clientIpAddress,
																	':routednetaddress' => $routedNetAddress,
																	':routednetnetworkmask' => $routedNetNetworkMask
																	));
			if (!$res)
			{
				$err="Could not add new client!";
				return FALSE;
			}
		} else {
			$mobileIpSpi=1000+$clientNum;
			mt_srand(makeSeed());
			$mobileIpSharedSecret="";
			for ($i=0; $i<16; $i++)
				$mobileIpSharedSecret=$mobileIpSharedSecret 
					. str_pad(dechex(mt_rand(0,255)),2,"0", STR_PAD_LEFT);

			$query = "INSERT INTO VpnClients (ClientName, SystemSerialNumber, SystemType, "
							. "Description, Protocol, Nat, RedirectGateway, V4ClientAddress, "
							. "V4NetworkAddress, V4NetworkNetmask, MobileIpSpi, MobileIpSharedSecretEncoding, "
							. "MobileIpSharedSecret, MobileIpAuthenticationType) VALUES (:clientname, "
							. ":serial, :type, :description, :protocol, :nat, "
							. ":redirectgateway, :clientipaddress, :routednetaddress, "
							. ":routednetnetworkmask, :mobileipspi, 'hex', :mobileipsharedsecret, "
							. "'prefix-suffix-md5')";
			$stmt = $cfg->pdb->prepare($query);
			$res = $stmt->execute(array(':clientname' => $clientName,
																	':serial' => $serial,
																	':type' => $type,
																	':description' => $description,
																	':protocol' => $protocol,
																	':nat' => $nat,
																	':redirectgateway' => $redirectGateway,
																	':clientipaddress' => $clientIpAddress,
																	':routednetaddress' => $routedNetAddress,
																	':routednetnetworkmask' => $routedNetNetworkMask,
																	':mobileipspi' => $mobileIpSpi,
																	':mobileipsharedsecret' => $mobileIpSharedSecret
										));
		}
		if (!$res)
		{
			$err="Could not add new client!";
			return FALSE;
		}
		return TRUE;
	}

?>
