<?
$SECTION=2;
$PAGE=1;
require_once("header.php");
require_once("utils.php");
require_once("config.php");

$clientname=$_GET['client'];

// retrieve client info
$query = "SELECT * FROM VpnClients WHERE ClientName=:clientname";
$stmt = $cfg->pdb->prepare($query);
$stmt->execute(array(':clientname' => $clientname));
$clientdata = $stmt->fetch(PDO::FETCH_ASSOC);
$protocol = $clientdata['Protocol'];

// retrieve connnected client info
if ($protocol=="openvpn")
{
	$openvpnclients = Array();
	$openvpnclients = connectedOpenVpnClients(7505);

	if ($openvpnclients)
	{
		foreach ($openvpnclients as &$client) {
			$currentname = substr(trim($client["name"]), strlen("OPENVPN_"));
			if ("$clientname"=="$currentname")
			{
					$vpnip = $client["address"];
					$internetip = $client["source"];
					break;
			}
		}
	}
} else {
	$mobileip_connected_file="/tmp/vpnportal/mobileip_clients/connected";
	if (file_exists($mobileip_connected_file))
	{
		$f=fopen($mobileip_connected_file,"r");
		if ($f)
		{
			while ($client=fgets($f))
			{
				$params = explode(" ", $client);
				$currentname=trim($params[2]);
				if ("$clientname"=="$currentname")
				{
					$vpnip = $params[0];
					$internetip = $params[1];
					break;
				}
			}
			fclose($f);
		}
	}
}

?>

<div class="item">
	<div class="content_top">
		<h1>Remote Stations</h1>
		<br />
		<h2>Station Details</h2>
		<br />
		<h3><?=$clientname ?><? $desc=htmlspecialchars($clientdata['Description'], ENT_QUOTES, 'UTF-8'); if (strlen($desc)) echo " / $desc"; ?></h3>
		<br />
	</div>
</div>

<div class="item">
	<div class="content_main">
		<table>
			<tr>
				<td><?=_("Type") ?>:<td>
				<td><? if ($protocol=="openvpn") echo "OpenVPN"; else echo "Mobile IP"; ?><td>
			</tr>
			<tr>
				<td><?=_("Connected") ?>:<td>
				<td><?=(isset($vpnip)) ? "<font color=\"green\">Yes</font>" : "<font color=\"red\">No</font>" ?><td>
			</tr>
<? if (isset($internetip)) { ?>
			<tr>
				<td><?=_("Internet IP Address") ?>:<td>
				<td><?=htmlspecialchars($internetip, ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
<? } ?>
			<tr>
				<td><?=_("VPN IP Address") ?>:<td>
				<td><?=htmlspecialchars($clientdata['V4ClientAddress'], ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
			<tr>
				<td><?=_("Routed Network Address") ?>:<td>
				<td><?=htmlspecialchars($clientdata['V4NetworkAddress'], ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
			<tr>
				<td><?=_("Routed Network Mask") ?>:<td>
				<td><?=htmlspecialchars($clientdata['V4NetworkNetmask'], ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
			<tr>
				<td><?=_("Uses 1:1 NAT") ?>:<td>
				<td><?=($clientdata['Nat']==1) ? _("Yes") : _("No") ?><td>
			</tr>
			<tr>
				<td><?= _("System Type")?>:<td>
				<td><?=htmlspecialchars($clientdata['SystemType'], ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
			<tr>
				<td><?= _("System Serial Number")?>:<td>
				<td><?=htmlspecialchars($clientdata['SystemSerialNumber'], ENT_QUOTES, 'UTF-8'); ?><td>
			</tr>
		</table>
		<br /><br />
<? if ($expertMode) { ?>
		<form method="post" action="vpn-client-config-file.php" name="form1">
			<div id="cnt_right_bottom">
				<input type="hidden" name="client" value="<?=htmlspecialchars($clientname, ENT_QUOTES, 'UTF-8'); ?>" />
				<input type="submit" name="Download" value="<?=_("Download Configuration")?>" ?>
			</div>
		</form>
		<br /><br />
<? } ?>
		<form method="post" action="vpn-client-delete.php" name="form1">
			<div id="cnt_right_bottom">
				<input type="hidden" name="client" value="<?=htmlspecialchars($clientname, ENT_QUOTES, 'UTF-8'); ?>" />
				<input type="submit" name="Delete" value="<?=_("Delete Station")?>" />
			</div>
		</form>
	</div>
</div> 

<? require_once("footer.php") ?>
